/*************************************************************************
# Copyright (C) 2006 Mike Lear <mikeofthenight2003@yahoo.com>
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include "options.h"
using namespace MJL; // mikes namespace
using std::cout;
using std::endl;


int main(int argc, char *argv[]) {
	unsigned int mx=3;
	unsigned int mod;
	std::set_terminate(last_chance);

	if(argc != 2) {
	   errno = ENOENT;
	   sys_err("Filename required");
	} 
	if(!(getuid())) {
	   errno = EPERM;
	   sys_err("vpac must not be run as root");
	} 
	   	string bcmp = argv[1];
        Options Oop(bcmp);
			mod = MJL::mode;
			std::string build;
			std::string res = Oop.readfl("cmdline.arg");
			std::flush(cout);
        if((operator==("ON",res)) && ((mod &= ~0x10)!= 4)) {
            cout << "Enter Build Files: " << std::flush;
			getline(std::cin,build);
			} 
			copy_right(0xB049E27F,buffer); 
		if(build.size()) { 
		switch(MJL::mode) {
			case 1: 	Oop.readfl("c_options");
						Oop.parse_cmd_line(build);
						Oop.find_h_files(MJL::loc,MJL::loh);
						if(MJL::linc.size()) 
						Oop.find_h_files(MJL::loc,MJL::linc);
						MJL::mode=1;
						break;
			case 2:		Oop.readfl("cc_options");
						Oop.parse_cmd_line(build);
						Oop.find_h_files(MJL::loc,MJL::loh);
						if(MJL::linc.size()) 
						Oop.find_h_files(MJL::loc,MJL::linc);
						MJL::mode=2;
						break;
			case 3:		Oop.readfl("asm_options");
						Oop.parse_cmd_line(build);
						Oop.find_h_files(MJL::loc,MJL::linc);
						if(MJL::loh.size())
						Oop.find_h_files(MJL::loc,MJL::loh);
						MJL::mode=3;	
						break;
			default:	break;
			}
		} 
						if(MJL::mode <= 2) {
						Oop.find_h_files(bcmp,MJL::loh);
						} else 
						if(MJL::mode == 3) {	
						Oop.find_h_files(bcmp,MJL::linc);
						}
		switch(MJL::mode)  
			{
			case 1: 	mx = Oop.check_age(bcmp);
						switch(mx){
							case 1: 	Oop.readfl("c_options");
										Oop.bcompile("gcc",bcmp);
										Oop.readfl("c_libraries");
										Oop.blink("gcc"); 
										break;
							case 2: 	Oop.readfl("c_libraries");
										Oop.blink("gcc");
										break;
							case 3:		Oop.show_name();	
										break;
							default: 	break;
							}
							break;
			case 2:		mx = Oop.check_age(bcmp);
						switch(mx) {
							case 1:	 	Oop.readfl("cc_options");
										Oop.bcompile("g++",bcmp);
										Oop.readfl("cc_libraries");
										Oop.blink("g++");
										break;
							case 2:		Oop.readfl("cc_libraries");
										Oop.blink("g++");
										break;
							case 3:		Oop.show_name();
										break;
							default:    break;
							}
							break;
			case 3: 	mx = Oop.check_age(bcmp);
						switch(mx) {
							case 1: 	Oop.readfl("asm_options");
										Oop.bcompile("nasm",bcmp);
										Oop.readfl("asm_libraries");
										Oop.blink("ld");
										break;
							case 2:		Oop.readfl("asm_libraries");
										Oop.blink("ld");
										break;
							case 3:		Oop.show_name();	
										break;
							default:	break;
							}
							break;
			case 4:  	Oop.skipifpl("perl",bcmp);
							break;
							default: break;
							}   
			return 0;
			}
