/*************************************************************************
# Copyright (C) 2006 Mike Lear <mikeofthenight2003@yahoo.com>
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <unistd.h>
#include <pwd.h>

using namespace std;
struct passwd *pw;
const string file("cmdline.arg");

template<class Any>
void Swap(Any &a,Any &b);


int main() {
ifstream fin;
ofstream fout;
string ost,a,b;
int c,d;

    if(!(pw = getpwuid(getuid()))) {
              endpwent();
        cerr << "Unable to obtain user's home directory." << endl;
        return 1;
    } else {
     ostringstream os;
     os << pw->pw_dir << "/etc/" << file << ends;
     ost = os.str();
     endpwent();
    }
    
   fin.open(ost.c_str());
	if(fin.is_open() == false) {   
	    fout.open(ost.c_str());    
	 if(fout.is_open() == false) {   
	    cerr << "Unable to create " << ost.c_str() << endl;
	    fin.clear();
	    return 1;
	 }
	 a="ON"; b="OFF";
	 c=1; d=0; 
	fout  << a << endl;
	fout  << b << endl;
	fout  << c << endl;
	fout  << d << endl;
      	fout.close();
   }
	getline(fin,a);
	getline(fin,b);
	fin >> c;
	fin >> d;
	fin.close();
    fout.open(ost.c_str());
	if(fout.is_open() == false) {
	    cerr << "Unable to open " << ost.c_str() << endl;
	    fout.clear();
	    return 1;
   }
    Swap(c,d);  
    fout  << a << endl;
    fout  << b << endl;
    fout  << c << endl;
    fout  << d << endl;
    fout  << endl;  
    fout << "This file is generated by Vpac(vpacs)" << endl;
    fout << "Please DO NOT EDIT....!" << endl;
    fout.close();
   if(d) {
    cout  << "Show cmd: ON" << endl;
   } else {
    cout  << "Show cmd: OFF" << endl;
   }
return 0;  
}

template <class Any>
void Swap(Any &a,Any &b) {
	Any temp;
	temp = a;
	a = b;
	b = temp;
}
