/*************************************************************************
# Copyright (C 2006 Mike Lear <mikeofthenight2003@yahoo.com>
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**************************************************************************/
#include <iostream>      
#include <fstream>        
#include <unistd.h>           
#include <cstdlib>                
#include <sstream> 
#include <cstring>
#include <pwd.h>                  
#include "rc4.h"
using namespace std;                   
struct passwd *pw;                


 
	ostringstream mosx,mosy;             
	string name,s1,ost;
	string mostx,mosty;           
	const string file("/.vimrc");
	extern string rcx;
	unsigned int mode=12;               
	unsigned int m;
	char command[5];                   
	char modes[11][5] = { 
		".c",".cc",".C",".cpp",".CPP",".c++",".asm",".s",".S",".pl",".pm"
	};
	string crx("Copyright (C) Mike Lear 2005-6");	
	Rc4_ctx ctx;

int main(int argc,char *argv[]) {                
	
	if(argc == 2) {
		name = argv[1];
		m = name.find_last_of(".");
	if(m != string::npos) {
		s1.assign(name,m,name.size());
	} else { 
		cerr << "Bad Filename! No extension?" << endl;
		exit(EXIT_FAILURE);
		}
		} 

		if(argc == 2) {
			strcpy(command,(char *)s1.c_str());
		for(m=0; m<11; m++){
			if(strcmp(command,&modes[m][0]) == 0)
				mode = m;
			}
		} 
		ctx.rc4_set_key(&ctx,crx.size(),crx);
		ctx.rc4(&ctx,rcx.size(),rcx,rcx);
		
	if((argc == 1) || (mode == 12)) {
		cout << rcx.c_str() << endl;
		exit(EXIT_FAILURE);
		} switch (mode) {  
				case 0:  			 
mosx << ":map <silent> <C-X> ^i/*A*/^j" << ends; 
mosy << ":map <silent> <C-Y> ^:s!\\/\\*!:s/\\([^*]*\\)\\*\\//\\1j" << ends; 					break;
				case 1: ; case 2: ; case 3: ; case 4: ; case 5: 			  
mosx << ":map <silent> <C-X> ^i// A^j\\_^." << ends;   
mosy << ":map <silent> <C-Y> :s/\\/\\/ \\([^*]*\\)/\\1j\\_^<CR>" << ends;   
					break;  
				case 6: ;  case 7: ; case 8:  			 
mosx << ":map <silent> <C-X> ^i;;; A^j\\_^." << ends; 
mosy << ":map <silent> <C-Y> :s/;;; \\([^*]*\\)/\\1j\\_^<CR>" << ends; 
					break;
			    case 9: ; case 10:  			
mosx << ":map <silent> <C-X> ^i ## A^j\\_^." << ends; 
mosy << ":map <silent> <C-Y> :s/ \\#\\# \\([^*]*\\)/\\1j\\_^. " << ends; 
					break;
				default: cout << "Bad filename!\n";
					exit(EXIT_FAILURE);
					break;
					}
		
		if(!(pw = getpwuid(getuid()))) {
			endpwent();
			cerr << "Unable to obtain user's home directory." << endl;
			exit(EXIT_FAILURE);
		} else {
			ostringstream os;
			os << pw->pw_dir << file << ends;
			ost = os.str();
			endpwent();
			}

		fstream finout;
		finout.open(ost.c_str(),ios_base::in|ios_base::out);
		if(!finout.is_open()) {
			cerr << "Unable to open " << file << endl;
			exit(EXIT_FAILURE);
			}
		mostx = mosx.str().c_str();
		mosty = mosy.str().c_str();
		finout.seekg(0,ios_base::beg);
		finout << mostx << "\n" << flush;
		finout << mosty << "\n" << flush;
		finout.close();
		cout << "ok\n";
	return(0);
}
